#include <stdio.h>
#include <split-c/split-c.h>
#include <split-c/com.h>
#include <stdlib.h>
#include "modes.h"

#define RADIX          65536
#define RADIX_MIN_1    65535
#define LOG_RADIX         16

/* a 8 bit bucket and a 32 bit bucket if the first bucket overflows */
static unsigned char  buckets[RADIX];
static unsigned int   buck[RADIX];

void inline
local_radix_sort_up(int R, int *c, int *t)
{
    unsigned int *x;
    int i, j, sum, temp;

    /* Init both buckets */
    for (j = 0; j < RADIX; ++j) {
	buckets[j] = 0;
	buck[j] = 0;
    }

    /* if 1st bucket overflows icr the 2nd bucket */
    for (j = 0; j < R; j++) {
	if ((++buckets[*(((unsigned short *)&c[j])+1)]) == 0)
	    buck[*(((unsigned short *)&c[j])+1)]++;
    }
    
    sum = 0;
    for (j = 0; j < RADIX; ++j) {
	temp = buckets[j] + buck[j]*256;
	buck[j] = sum;
	sum += temp;
    }
    
    for (j = 0; j < R; j++) {
	sum = buck[*(((unsigned short *)&c[j])+1)]++;
	t[sum] = c[j];
    }

    x = t;
    t = c;
    c = x;

    /* Init both buckets */
    for (j = 0; j < RADIX; ++j) {
	buckets[j] = 0;
	buck[j] = 0;
    }

    for (j = 0; j < R; j++) {
	if ( (++buckets[*((unsigned short *)&c[j])]) == 0 )
	    buck[*((unsigned short *)&c[j])]++;
    }
    
    sum = 0;
    for (j = 0; j < RADIX; ++j) {
	temp = buckets[j] + buck[j]*256;
	buck[j] = sum;
	sum += temp;
    }

    for (j = 0; j < R; j++) {
	sum = buck[*((unsigned short *)&c[j])]++;
	t[sum] = c[j];
    }
}

void inline local_radix_sort_down(int R, int *c, int *t)
{
    unsigned int *x;
    int i, j, sum, temp;

    /* Init both buckets */
    for (j = 0; j < RADIX; ++j) {
	buckets[j] = 0;
	buck[j] = 0;
    }

    /* if 1st bucket overflows icr the 2nd bucket */
    for (j = 0; j < R; j++) {
	if ((++buckets[*(((unsigned short *)&c[j])+1)]) == 0)
	    buck[*(((unsigned short *)&c[j])+1)]++;
    }    
    sum = 0;
    for (j = 0; j < RADIX; ++j) {
	temp = buckets[j] + buck[j]*256;
	buck[j] = sum;
	sum += temp;
    }
    
    for (j = 0; j < R; j++) {
	sum = buck[*(((unsigned short *)&c[j])+1)]++;
	t[sum] = c[j];
    }

    x = t;
    t = c;
    c = x;

    /* Init both buckets */
    for (j = 0; j < RADIX; ++j) {
	buckets[j] = 0;
	buck[j] = 0;
    }

    for (j = 0; j < R; j++) {
	if ( (++buckets[*((unsigned short *)&c[j])]) == 0 )
	    buck[*((unsigned short *)&c[j])]++;
    }
    
    sum = 0;
    for (j = 0; j < RADIX; ++j) {
	temp = buckets[j] + buck[j]*256;
	buck[j] = sum;
	sum += temp;
    }

    for (j = 0; j < R; j++) {
	sum = buck[*((unsigned short *)&c[j])]++;
	t[(R-1)-sum] = c[j];
    }
}

void local_radix_sort(int outerdim, int R, int *c, int *t)
{
  if (MYPROC & (BITMASK(outerdim))) local_radix_sort_up(R, c, t);
  else local_radix_sort_down(R, c, t);
}



