/*									tab:8
 *
 * connect.h - header file for connected components code
 *
 * "Copyright (c) 1993 by Steve Lumetta and The Regents of the University 
 * of California.  All rights reserved."
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 *
 * Author:	    Arvind Krishnamurthy and Steve Lumetta
 * Version:	    44
 * Creation Date:   Wed May 11 15:52:13 1994
 * Filename:	    connect.h
 * History:
 */

#ifndef _CONNECT_H_
#define _CONNECT_H_

typedef struct edge_t {
    struct edge_t *global next;
    struct node_t *global node;
} edge_t;

typedef struct node_t {
    int value;
    struct node_t *queue;
    struct edge_t *global edges;
    struct node_t *global parent;
    int stagnant;
} node_t;

extern int random_seed;
extern node_t *spread node_list;
extern double timer, local_time, update_time, global_time;
extern int n_ptr_doubles;
extern FILE *fp;

typedef enum {GRAPH_2D, GRAPH_3D, GRAPH_DEG_3, GRAPH_RANDOM} graph_t;

int all_make_graph (graph_t gtype, int n_vertices, int percent);
node_t *all_local_traversal (int num_nodes);
node_t *all_find_components (int n_vertices, node_t *comp_list);


#endif
