#include <split-c/split-c.h>
#include <malloc.h>

int ipth[MRFACES + 1], ipte[MREDGES + 1];
int npth[MHCOEF], npte[MECOEF];
double coefh[MHCOEF], coefe[MECOEF];
double hds[MDEDGES], eds[MREDGES];

int iabedg[MABDRY], imc[MMC];
     
double exx, eyy, ezz, hxx, hyy, hzz;int ispedg[MSPEC];
double xsp[MSPEC], ysp[MSPEC], zsp[MSPEC];
double coefsp[MSPEC], rcossp[MSPEC][3];
int nsp[MSPEC];

int ioredg[MIOR], iodedg[MIOD];

read_files ()
{
	FILE *in_data = fopen("rundat.dat", "r");
	int nredges, ndedges, nrfaces, niedg, nbedg, nhcoef, necoef, nmc;
	int nabdry, nior, niod, idrive, nstep, nspec;
	double dt, t0;
	int i, trash;  /* Fortran data file wrapper trash */
	int blocks;
	
	/* Read in parameters from ASCII file (rundat.dat) */
	fscanf(in_data, "%d%*[^\n]\n", &nredges);
	fscanf(in_data, "%d%*[^\n]\n", &nrfaces);
	fscanf(in_data, "%d%*[^\n]\n", &niedg);
	fscanf(in_data, "%d%*[^\n]\n", &nbedg);
	fscanf(in_data, "%d%*[^\n]\n", &nhcoef);
	fscanf(in_data, "%d%*[^\n]\n", &necoef);
	fscanf(in_data, "%d%*[^\n]\n", &nmc);
	fscanf(in_data, "%d%*[^\n]\n", &nabdry);
	fscanf(in_data, "%d%*[^\n]\n", &nior);
	fscanf(in_data, "%d%*[^\n]\n", &niod);
	fscanf(in_data, "%d%*[^\n]\n", &idrive);
	fscanf(in_data, "%d%*[^\n]\n", &nstep);
	fscanf(in_data, "%lf%*[^\n]\n", &dt);
	fscanf(in_data, "%lf%*[^\n]\n", &t0);
	fscanf(in_data, "%d%*[^\n]\n", &nspec);
/*	fscanf(in_data, "%d%*[^\n]\n", &irstrt);*/

	ndedges = nrfaces + nbedg;
	  
	for (i = 0; i < nspec; i++) {
		fscanf(in_data, "%d%lf%lf%lf%lf%*s[^\n]\n", ispedg + i,
				xsp + i, ysp + i, zsp + i, coefsp + i);
		fscanf(in_data, "%lf%lf%lf%*[^\n]\n", rcossp[i], rcossp[i] + 1,
				rcossp[i] + 2);
		fscanf(in_data, "%d%*[^\n]\n", nsp + i);
	}

	fclose(in_data);

	printf("Done reading rundat.dat\n");
	
	/* Report runtime parameters */
	printf("nredges: %d\n", nredges);
	printf("nrfaces: %d\n", nrfaces);
	printf("ndedges: %d\n", ndedges);
	printf("nhcoef: %d\n", nhcoef);
	printf("necoef: %d\n", necoef);
	printf("nmc: %d\n", nmc);
	printf("nabdry: %d\n", nabdry);
	printf("nior: %d\n", nior);
	printf("niod: %d\n", niod);
	printf("idrive: %d\n", idrive);
	printf("nstep: %d\n", nstep);
	printf("nspec: %d\n", nspec);
	printf("dt: %lf\n", dt);

	/* read binary data file */
	in_data = fopen("coefs.dat", "rb");
	/* These 4 may need to be wrapped in trash int readers... */
	fread(imc, sizeof(int), nmc, in_data);
	fread(iabedg, sizeof(int), nabdry, in_data);
	fread(ioredg, sizeof(int), nior, in_data);
	fread(iodedg, sizeof(int), niod, in_data);

	/* read in coefficient arrays from binary file */
	blocks = nhcoef/1024 + 1;
	for (i = ioff = 0; i < blocks - 1; i++, ioff += 1024) {
		fread(npth + ioff, sizeof(int), 1024, in_data);
		fread(coefh + ioff, sizeof(double), 1024, in_data);
	}
	fread(&trash, sizeof(int), 1, in_data);
	fread(npth + ioff, sizeof(int), nhcoef - ioff, in_data);
	fread(&trash, sizeof(int), 1, in_data);
	fread(&trash, sizeof(int), 1, in_data);
	fread(coefh + ioff, sizeof(double), nhcoef - ioff, in_data);
	fread(&trash, sizeof(int), 1, in_data);
 
	blocks = necoef/1024 + 1;
	for (i = ioff = 0; i < blocks - 1; i++, ioff += 1024) {
		fread(npte + ioff, sizeof(int), 1024, in_data);
		fread(coefe + ioff, sizeof(double), 1024, in_data);
	}
	fread(&trash, sizeof(int), 1, in_data);
	fread(npte + ioff, sizeof(int), necoef - ioff, in_data);
	fread(&trash, sizeof(int), 1, in_data);
	fread(&trash, sizeof(int), 1, in_data);
	fread(coefe + ioff, sizeof(double), necoef - ioff, in_data);
	fread(&trash, sizeof(int), 1, in_data);

	fread(&trash, sizeof(int), 1, in_data);
	fread(ipth, sizeof(int), nrfaces + 1, in_data);
	fread(&trash, sizeof(int), 1, in_data);
	fread(&trash, sizeof(int), 1, in_data);
	fread(ipte, sizeof(int), nredges + 1, in_data);
	fread(&trash, sizeof(int), 1, in_data);
	fclose(in_data);

	printf("Done reading coefs.dat\n");
}
