/*									tab:8
 * local.c - Do a local FFT
 * 
 * "Copyright (c) 1992 The Regents of the University of California.
 * All rights reserved.
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 		Thorsten von Eicken
 * Version:		4
 * Creation Date:	Fri Oct  2 22:32:15 PDT 1992
 * Filename:		local.c
 * History:
 */

#include "defs.h"

int flop = 0;

static void
op(complex_t X[], int i1, int i2, complex_t *tf)
{
	double re1, re2, re3, re4;
	double im1, im2, im3, im4;
	extern int op_count;

	re1 = X[i1].re; im1 = X[i1].im;
	re2 = X[i2].re; im2 = X[i2].im;
	X[i1].re = re1 + re2;
	X[i1].im = im1 + im2;
	re3 = re1 - re2;
	re4 = tf->re;
	im3 = im1 - im2;
	im4 = tf->im;
	X[i2].re = (re3 * re4) - (im3 * im4);
	X[i2].im = (re3 * im4) + (im3 * re4);

	flop += 10;
}

void
local_fft(int n, int bit, complex_t X[n], complex_t TF[n/2])
{
	int i1, i2;

	for(; bit>0; bit>>=1) {
		for(i1=0; i1<n; i1+=2*bit) {
			for(i2=0; i2<bit; i2++) {
				op(X, i1+i2, i1+i2+bit, &TF[0]);
			}
		}
	}
}
