#include <stdio.h>
#include <split-c/split-c.h>
#include <split-c/control.h>
#include "all_matrix.h"


/* A simple unblocked matrix multiplication. The only
   trick is to stagger the starting point for the vector
   vector dot products that makes up the inner loop.
*/
void all_matrix_mult(int n, int r, int m, 
		     double C[n][m]::,
		     double A[n][r]::,
		     double B[r][m]::)
{
    int i,j,k,l,kk;
    for_my_2D(i,j,l,n,m) {
	double sum = C[i][j];
	kk = MYPROC%r;
	for (k=0;k<r;k++) {
	    sum = sum + A[i][kk]*B[kk][j];
	    kk++;
	    if (kk==r) kk=0;
	}
	C[i][j] = sum;
    }
    barrier();
}

void all_fill_matrix(int r, int c, 
		     double A[r][c]::, 
		     double f(int, int))
{
    int i,j,l;
    for_my_2D(i,j,l,r,c) A[i][j] = f(i,j);
    barrier();
}

void all_zero_matrix(int r, int c, double A[r][c]::)
{
    int i,j,l;
    for_my_2D(i,j,l,r,c) A[i][j] = 0.0;
    barrier();
}

