/*									tab:4
 *
 * shell.h - Include file for shell.sc
 *
 * "Copyright (c) 1993 and The Regents of the University 
 * of California.  All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 			Andrea C. Dusseau
 * Version:			3
 * Creation Date:	Fri Jan 22 16:33:43 1993
 * Filename:		shell.h
 * History:
 *	ssl	3	Fri Dec 10 00:31:24 1993
 *		Use PROCSLOG instead of log2.
 */

#ifndef __SHELL_H__
#define __SHELL_H__

/* ------------------------ Definitions  ------------------ */
#define MERGE_COLUMN(self,d) \
  (int)(((1<<(d))-1-(self)%(1<<(d)))+((1<<(d))*((self)/(1<<(d))))) 

#define MERGE_ITERATIONS PROCSLOG
#define swap(a,b) { void *spread tmp;  \
		    tmp  = a; a = (void *spread)b; b = tmp; }


/* ------------------------ Function Prototypes ------------------ */
void inline GenRandKeys(int keys[], int num);
void inline LocalSort(int *keys, int first, int last);

/*
 * Currently, the split-c compilier can not typecheck procedure
 * definitions that have spread arrays of a variable size as parameters
 */
#if 0
inline MergeGetLower(int num, int  (*spread keys)[num], int (*spread merged)[num], 
		   int proc, int b);
inline MergeGetHigher(int num, int (*spread keys)[num], int (*spread merged)[num], 
		    int proc, int b);
inline MergeWithSelf(int num, int (*spread keys)[num], int (*spread merged)[num]); 
inline MopUp(int num, int (*spread keys)[num], int (*spread merged)[num], int b);
#endif


#endif /* __SHELL_H__ */
